package gui;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;

import com.sun.java.swing.plaf.motif.MotifGraphicsUtils;

public class CustomTableHeadRenderer extends DefaultTableCellRenderer {

	private static final long serialVersionUID = -5095847117409122481L;
	public Component getTableCellRendererComponent( JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		JTableHeader header = table.getTableHeader();
		setForeground(header.getForeground());
		setBackground(header.getBackground());
		setFont(header.getFont());

		setText(value == null ? "" : value.toString());
		setBorder(UIManager.getBorder("TableHeader.cellBorder"));
		setHorizontalAlignment(SwingConstants.CENTER);
		setHorizontalTextPosition(SwingConstants.LEFT);

		SortableTableModel model = (SortableTableModel)table.getModel();
		if(column==model.getLastSelectedColumn()) {
			if (model.sortColumnDesc[column]) setIcon(new ImageIcon(MotifGraphicsUtils.class.getResource("icons/ScrollUpArrow.gif")));
			else setIcon(new ImageIcon(MotifGraphicsUtils.class.getResource("icons/ScrollDownArrow.gif")));
		}
		else setIcon(null);
		
		return this;
	}
}
