package gui;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import javax.swing.text.JTextComponent;

public class DefaultKontextMenu extends JPopupMenu {
	
	private static final long serialVersionUID = 9181534415694498322L;
	private JMenuItem mnuCopy;
	private JTextComponent txtParent;
	private Clipboard Zwischenablage;
	private Transferable transData;

	
	public DefaultKontextMenu(JTextComponent myParent) {
		super();
		txtParent = myParent;
		Zwischenablage = Toolkit.getDefaultToolkit().getSystemClipboard();

		this.addPopupMenuListener(new PopupMenuListener(){
			public void popupMenuCanceled(PopupMenuEvent e) {
				mnuCopy.setEnabled(true);
			}
			public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
				mnuCopy.setEnabled(true);
			}
			public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
				transData = Zwischenablage.getContents(null);
				if(txtParent.getSelectedText()==null) mnuCopy.setEnabled(false);
			}
			
		});

		mnuCopy = new JMenuItem("Kopieren");
		mnuCopy.addMouseListener(new MouseListener() {
			public void mouseEntered (MouseEvent e) {}
			public void mouseExited  (MouseEvent e) {}
			public void mousePressed (MouseEvent e) {}
			public void mouseReleased(MouseEvent e) { copy(); }
			public void mouseClicked (MouseEvent e) {}
		});
	    add(mnuCopy);
	}
	
	public void cut() {
		if(txtParent.isEditable()) {
			String newText = "";
	        String selText = txtParent.getSelectedText();
	        Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(selText), null);
	        if(txtParent.getSelectionStart()>0)
	        	newText += txtParent.getText().substring(0, txtParent.getSelectionStart());
	        newText += txtParent.getText().substring(txtParent.getSelectionEnd());
			int CarretPosition = txtParent.getSelectionStart();
	        txtParent.setText(newText);
			txtParent.setCaretPosition(CarretPosition);
		}
	}
	public void copy() {
		if(this.mnuCopy.isEnabled()) {
			Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(txtParent.getSelectedText()), null);
		}
	}
	public void paste() {
		if(txtParent.isEditable()) {
			try {
				String newText = "";
				String selText = "";
				transData = Zwischenablage.getContents(null);
				if ((transData != null) && transData.isDataFlavorSupported(DataFlavor.stringFlavor)) {
					selText = (String)transData.getTransferData(DataFlavor.stringFlavor); 
				}
				newText += txtParent.getText().substring(0, txtParent.getSelectionStart());
				newText += selText;
				newText += txtParent.getText().substring(txtParent.getSelectionEnd());
				int CarretPosition = txtParent.getSelectionStart();
				txtParent.setText(newText);
				txtParent.setCaretPosition(CarretPosition+selText.length());
			}
			catch (UnsupportedFlavorException e1) { e1.printStackTrace(); }
			catch (IOException e1) { e1.printStackTrace(); }
		}
	}
}
