package gui;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.JLabel;
import javax.swing.JTextField;

public class HexField extends JTextField {
	
	private static final long serialVersionUID = 3732908024107719766L;
	public HexField() {
		super();
		setHorizontalAlignment(JLabel.RIGHT);
		addFocusListener(new FocusListener() {
			public void focusGained(FocusEvent e) {
				setSelectionStart(0);
				setSelectionEnd(getText().length());
			}
			public void focusLost(FocusEvent e) {
				if(getText().length()>2) setText(getText().substring(0, 2));
			}
		});
		this.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e)		{ check(e); }
			public void keyReleased(KeyEvent e)	{ check(e); }
			public void keyTyped(KeyEvent e)		{ check(e); }
		});
	}
	
	private void check(KeyEvent e) {
		char c = e.getKeyChar();
		if(c == 'a') { c = 'A'; e.setKeyChar('A'); }
		else if(c == 'b') { c = 'B'; e.setKeyChar('B'); }
		else if(c == 'c') { c = 'C'; e.setKeyChar('C'); }
		else if(c == 'd') { c = 'D'; e.setKeyChar('D'); }
		else if(c == 'e') { c = 'E'; e.setKeyChar('E'); }
		else if(c == 'f') { c = 'F'; e.setKeyChar('F'); }
		if(	c!='0' && c!='1' && c!='2' && c!='3' && c!='4' && c!='5' && c!='6' &&
			c!='7' && c!='8' && c!='9' && c!='A' && c!='B' && c!='C' && c!='D' &&
			c!='E' && c!='F' && e.getKeyCode()!=37 && e.getKeyCode()!=39 && e.getKeyCode()!=8 &&
			e.getKeyCode()!=127 && e.getKeyCode()!=35 && e.getKeyCode()!=36) e.consume();
		else if(isEnabled() && isEditable()) {
			String tmpText = getText();
			if(tmpText.length()==2 && e.getKeyCode()!=37 && e.getKeyCode()!=39 && e.getKeyCode()!=8 &&
				e.getKeyCode()!=127 && e.getKeyCode()!=35 && e.getKeyCode()!=36 && getSelectedText()==null) {
				e.consume();
			}
			else if(tmpText.length()>2) setText(tmpText.substring(0, 2));
		}
	}
}
