package gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.text.html.HTMLEditorKit;

public class StatusBar extends JPanel {
	private static final long serialVersionUID = 1478162707036066151L;

	private JEditorPane infoPane = null;
	private DefaultKontextMenu KontextMenu = null;

	public StatusBar() {
		super(new GridBagLayout());
		
		setBorder(BorderFactory.createMatteBorder(1, 0, 0, 0, Color.GRAY));
		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(2,10,1,10);
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1D;
		infoPane = new JEditorPane();
		infoPane.setEditorKit(new HTMLEditorKit());
		infoPane.putClientProperty(JEditorPane.HONOR_DISPLAY_PROPERTIES, true);
		infoPane.setEditable(false);
		infoPane.setOpaque(false);
		infoPane.setText("<html><body><strong>G3 Template Editor</strong> - Not for commercial use !!</body></html>");
		infoPane.setFont(new Font("Verdana" , Font.PLAIN, 11));

		KontextMenu = new DefaultKontextMenu(infoPane);
		infoPane.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e)  { showPopUp(e); }
			public void mouseReleased(MouseEvent e) { showPopUp(e); }
		});
		add(infoPane, c);
	}

	public void setStatusText(String text) { infoPane.setText(text); }
	
	public void setObjectInfo(String position, String cl, String name, String value) {
		setStatusText("<html><body><span style=\"color:#7F0055;font-weight:bold;\">" + cl +
					  "</span> " + name + "</span> <span style=\"color:#7700FF;\">" +
					  " { " + value + " }</span> - Hex-Adr.: [" + position + "]</body></html>");
	}

	private void showPopUp(MouseEvent e) {
		if(e.isPopupTrigger()) {
			KontextMenu.show(e.getComponent(), e.getX(), e.getY());
			this.requestFocus();
		}
	}
}
