package gui;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
import java.awt.Color;
import java.awt.Toolkit;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JTextField;

public class TextField extends JTextField {

	private static final long serialVersionUID = 8081968431030920564L;
	
	private int TextFieldLength = 0;
	private boolean isLimited = false;
	private Color DefaultBackgroundColor = Color.WHITE;
	private Color SelectionBackgroundColor = new Color(255,255,210);
	private boolean mechanicalChange = false;
	private boolean badCommata = false;
	
	public TextField() { createTextField(); }
	public TextField(int LimitLength) {
		isLimited = true;
		TextFieldLength = LimitLength;
		createTextField();
	}

	private void createTextField() {
		
		this.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {
				if(isEnabled() && isEditable() && e.getKeyCode()==110 && badCommata==false) {
					e.consume();
					badCommata = true;
				}
			}
			public void keyReleased(KeyEvent e) { if(isEnabled() && isEditable() && e.getKeyCode()==110) e.consume(); }
			public void keyTyped(KeyEvent e) {
				if(isEnabled() && isEditable() && badCommata) {
					e.consume();
					badCommata = false;
					int CaretPosition = getCaretPosition();
					setText(getText().substring(0, CaretPosition) + "," + getText().substring(CaretPosition));
					setCaretPosition(CaretPosition+1);
				}
			}
		});
		this.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e)  {}
			public void mouseEntered(MouseEvent e)  {}
			public void mouseExited(MouseEvent e)   {}
			public void mousePressed(MouseEvent e)  { showPopUp(e); }
			public void mouseReleased(MouseEvent e) { showPopUp(e); }
		});
		this.addFocusListener(new FocusListener(){
			public void focusGained(FocusEvent e) {
				if(isEnabled() && isEditable()) {
					setBackground(SelectionBackgroundColor);
					FocusGainedExtra();
				}
			}
			public void focusLost(FocusEvent evt) {
				if(isEnabled() && isEditable()) {
					setBackground(DefaultBackgroundColor);
					FocusLostExtra();
					setSelectionStart(0);
					setSelectionEnd(0);
				}
			}
		});
		if(isLimited) {
			this.addKeyListener(new KeyListener() {
				public void keyPressed(KeyEvent e) {}
				public void keyTyped(KeyEvent e) {}
				public void keyReleased(KeyEvent e) {
					if(isEnabled() && isEditable()) {
						String tmpText = getText(); 
						if(tmpText.length()>TextFieldLength) {
							Toolkit.getDefaultToolkit().beep();
							setText(tmpText.substring(0, TextFieldLength));
						}
					}
				}
			});
			this.setDocument(new TextFieldDocument(TextFieldLength));
		}
	}
	
	public void FocusLostExtra() {
		// Überschreiben für Extra Focus-Funktionen
	}

	public void FocusGainedExtra() {
		// Überschreiben für Extra Focus-Funktionen
	}
	
	private void showPopUp(MouseEvent e) {
		if(e.isPopupTrigger()) {
			this.requestFocus();
		}
	}

	public void setDefaultBackgroundColor(Color mColor) { DefaultBackgroundColor = mColor; }
	public void setSelectionBackgroundColor(Color mColor) { SelectionBackgroundColor = mColor; }
	
	public void setText(String t) {
		mechanicalChange = true;
		super.setText(t);
		super.setCaretPosition(0);
		mechanicalChange = false;
	}
	public boolean isMechanicalChange() { return mechanicalChange; }
}