package gui;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

public class TextFieldDocument extends PlainDocument {
	private static final long serialVersionUID = 5271623898437696724L;
	private int limit;
	// optional uppercase conversion
	private boolean toUppercase = false;

	public TextFieldDocument(int limit) {
		super();
		this.limit = limit;
	}
	   
	public TextFieldDocument(int limit, boolean upper) {
		super();
		this.limit = limit;
		toUppercase = upper;
	}
	 
	public void insertString (int offset, String  str, AttributeSet attr) throws BadLocationException {
		if (str == null) return;

		if ((getLength() + str.length()) <= limit) {
			if (toUppercase) str = str.toUpperCase();
			super.insertString(offset, str, attr);
		}
	}
}