package main.data;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
public class Converter {
	
	public static final long UInt16ToLong(byte[] value) {
		int it = 0;
		long retValue = 0;
		for (int shift=0; shift<16; shift+=8) {
			retValue |= ((value[it]&0xff))<<shift;
			it++;
		}
		return retValue;
	}

	public static byte[] longToUInt16(long value) {
		int it = 0;
		byte[] tmpValue = new byte[2];
		for (int shift=0; shift<16; shift+=8) {
			tmpValue[it] = (byte)(0xFF&(value>>shift));
			it++;
		}
		return tmpValue;
	}
	
	public static final long UInt32ToLong(byte[] value) {
		int it = 0;
		long retValue = 0;
		for (int shift=0; shift<32; shift+=8) {
			retValue |= ((value[it]&0xff))<<shift;
			it++;
		}
		return retValue;
	}

	public static byte[] longToUInt32(long value) {
		int it = 0;
		byte[] retValue = new byte[4];
		for (int shift=0; shift<32; shift+=8) {
			retValue[it] = (byte)(0xFF&(value>>shift));
			it++;
		}
		return retValue;
	}
	
	public static long UInt64ToLong(byte[] value) {
		int it = 0;
		long retValue = 0;
		for (int shift=0; shift<64; shift+=8) {
			retValue |= ((long)(value[it]&0xff))<<shift;
			it++;
		}
		return retValue;
	}

	public static byte[] longToUInt64(long value) {
		int it = 0;
		byte[] retValue = new byte[8];
		for (int shift=0; shift<64; shift+=8) {
			retValue[it] = (byte)(0xFF&(value>>shift));
			it++;
		}
		return retValue;
	}

	public static float byteToFloat(byte[] value) {
		int num = ((value[3]<<24)&0xFF000000) | ((value[2]<<16)&0xFF0000) | ((value[1]<<8)&0xFF00) | (value[0]&0xFF);
		return Float.intBitsToFloat(num);
	}

	public static byte[] floatToByte(Float value) {
		int intBits = Float.floatToIntBits(value);
		byte[] retValue = new byte[4];
		retValue[0]=(byte)((intBits&0x000000ff)>>0);
		retValue[1]=(byte)((intBits&0x0000ff00)>>8);
		retValue[2]=(byte)((intBits&0x00ff0000)>>16);
		retValue[3]=(byte)((intBits&0xff000000)>>24);
		return retValue;
	}

	public static String[] byteToHex(byte[] in) {
		byte ch = 0x00;
		if (in == null || in.length <= 0) return null;
		String pseudo[] = {"0", "1", "2","3", "4", "5", "6", "7", "8","9", "A", "B", "C", "D", "E","F"};
		String[] hexString = new String[in.length];

		for(int it=0; it<in.length; it++) {
			ch = (byte) (in[it] & 0xF0);
			ch = (byte) (ch >>> 4);
			ch = (byte) (ch & 0x0F);
			hexString[it] = pseudo[(int)ch];
			ch = (byte) (in[it] & 0x0F);
			hexString[it] += pseudo[(int)ch];
		}
		return hexString;
	}

	public static String byteToHexString(byte[] in) {
		String retValue = "";
		String[] hexArray = byteToHex(in);
		for(int it=0; it<hexArray.length; it++) retValue += hexArray[it] + " ";
		return retValue.trim();
	}

	public static byte hexToByte(String in) { return hexToByte(new String[]{in})[0]; }
	public static byte[] hexToByte(String[] in) {
		byte[] bts = new byte[in.length];
		for (int i = 0; i < bts.length; i++) bts[i] = (byte) Integer.parseInt(in[i], 16);
		return bts;
	}
	
	public static String longToHex(Long l) { return Long.toHexString(l).toUpperCase(); }
	public static String HTMLEntities(String html) { return html.replaceAll("<", "&lt;").replaceAll(">", "&gt;"); }
}
