package main.data;

import main.enums.KnownDataTypes;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
public class TPLE_Value {
	private TPLE_Class		parent		= null;
	private TPLE_String	name		= new TPLE_String();
	private TPLE_String	type		= new TPLE_String();
	private TPLE_String	sValue		= new TPLE_String();
	private long			position	= 0L;
	private byte[]			value		= new byte[0];
	
	public TPLE_Value(TPLE_Class p) { parent = p; }

	public TPLE_Class getParent() { return parent; }
	public void setParent(TPLE_Class parent) { this.parent = parent; }

	public TPLE_String getName() { return name; }
	public void setName(TPLE_String name) { this.name = name; }

	public TPLE_String getType() { return type; }
	public void setType(TPLE_String type) { this.type = type; }

	public byte[] getValue() { return value; }
	public void setValue(byte[] value) { this.value = value; }

	public long getPosition() { return position; }
	public void setPosition(long position) { this.position = position; }

	public TPLE_String getString() { return sValue; }
	public void setString(TPLE_String string) { sValue = string; }
	public void setStringValue(String string) { getParent().getParent().newStringValue(sValue.getIndex(), string); }

	public KnownDataTypes getDataType() { return KnownDataTypes.fromValue(type.getValue()); }
	
	public boolean isString() {
		switch(getDataType()) {
			case STRING:
			case MESH_RES_STRING:
			case ANIM_RES_STRING:
			case LOC_STRING:
				return true;
			default:
				return false;
		}
	}
	
	public boolean getBoolean() { return value[0]!=0; }
	public int getInteger() { return (int)Converter.UInt32ToLong(value); }
	public long getLong() { return Converter.UInt32ToLong(value); }
	public short getShort() { return (short)Converter.UInt16ToLong(value); }
	public float getFloat() { return Converter.byteToFloat(value); }
	public int getEnumInt() {
		return (int)Converter.UInt32ToLong(new byte[] { value[2], value[3], value[4], value[5] });
	}

	public void setValue(boolean value) { this.value = new byte[]{ value ? (byte)1 : (byte)0 }; }
	public void setValue(int value) { this.value = Converter.longToUInt32((long)value); }
	public void setValue(long value) { this.value = Converter.longToUInt32(value); }
	public void setValue(short value) { this.value = Converter.longToUInt16(value); }
	public void setValue(float value) { this.value = Converter.floatToByte(value); }
	public void setEnumInt(int value) {
		byte[] b = Converter.longToUInt32((long)value);
		this.value = new byte[] { 1, 0, b[0], b[1], b[2], b[3] };
	}

	public String toString() { return name.getValue(); }
}
