package main.enums;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
public enum KnownDataTypes {

	UNKNOWN(""),
	UNKNOWN_ENUM("bTPropertyContainer"),
	INTEGER("int"),
	LONG("long"),
	SHORT("short"),
	FLOAT("float"),
	BOOLEAN("bool"),
	STRING("bCString"),
	LOC_STRING("eCLocString"),
	MESH_RES_STRING("bCMeshResourceString"),
	ANIM_RES_STRING("bCAnimationResourceString"),
	ITEM_CATEGORY("bTPropertyContainer<enum gEItemCategory>"),
	ATTRIB_REQ_OPERATION("bTPropertyContainer<enum EAttribReqOperation>"),
	ATTRIB_MOD_OPERATION("bTPropertyContainer<enum EAttribModOperation>"),
	ACTION("bTPropertyContainer<enum gEAction>"),
	AI_MODE("bTPropertyContainer<enum gEAIMode>"),
	AMBIENT_ACTION("bTPropertyContainer<enum gEAmbientAction>"),
	ANI_STATE("bTPropertyContainer<enum gEAniState>"),
	ATTACK_REASON("bTPropertyContainer<enum gEAttackReason>"),
	ATTITUDE("bTPropertyContainer<enum gEAttitude>"),
	BEARING("bTPropertyContainer<enum gEBearing>"),
	CLASS("bTPropertyContainer<enum gEClass>"),
	DAMAGE_TYPE("bTPropertyContainer<enum gEDamageType>"),
	FOCUS("bTPropertyContainer<enum gEFocus>"),
	FOCUS_LOOK_AT("bTPropertyContainer<enum gEFocusLookAt>"),
	FOCUS_LOOK_AT_KEYS_FOR("bTPropertyContainer<enum gEFocusLookAtKeysFOR>"),
	FOCUS_NAME_TYPE("bTPropertyContainer<enum gEFocusNameType>"),
	FOCUS_PRIORITY("bTPropertyContainer<enum gEFocusPriority>"),
	GENDER("bTPropertyContainer<enum gEGender>"),
	GUARD_STATUS("bTPropertyContainer<enum gEGuardStatus>"),
	HIT_DIRECTION("bTPropertyContainer<enum gEHitDirection>"),
	LAST_FIGHT_AGAINST_PLAYER("bTPropertyContainer<enum gELastFightAgainstPlayer>"),
	NPC_TYPE("bTPropertyContainer<enum gENPCType>"),
	PARTY_MEMBER_TYPE("bTPropertyContainer<enum gEPartyMemberType>"),
	PLAYER_CRIME("bTPropertyContainer<enum gEPlayerCrime>"),
	POLITICAL_ALIGNMENT("bTPropertyContainer<enum gEPoliticalAlignment>"),
	SLOT("bTPropertyContainer<enum gESlot>"),
	SPECIES("bTPropertyContainer<enum gESpecies>"),
	TRADE_CATEGORY("bTPropertyContainer<enum gETradeCategory>"),
	USE_TYPE("bTPropertyContainer<enum gEUseType>"),
	COLLISION_GROUP("bTPropertyContainer<enum eECollisionGroup>"),
	DIRECTIONAL_SHADOW_TYPE("bTPropertyContainer<enum eEDirectionalShadowType>"),
	DYNAMIC_LIGHT_EFFECT("bTPropertyContainer<enum eEDynamicLightEffect>"),
	EVENT_TYPE("bTPropertyContainer<enum eEEventType>"),
	FINAL_BLEND("bTPropertyContainer<enum eEFinalBlend>"),
	LIGHTMAP_AMBIENT_OCCLUSION("bTPropertyContainer<enum eELightmapAmbientOcclusion>"),
	LIGHTMAP_TYPE("bTPropertyContainer<enum eELightmapType>"),
	PHYSIC_RANGE_TYPE("bTPropertyContainer<enum eEPhysicRangeType>"),
	PROPERTY_SET_TYPE("bTPropertyContainer<enum eEPropertySetType>"),
	SHAPE_GROUP("bTPropertyContainer<enum eEShapeGroup>"),
	SHAPE_MATERIAL("bTPropertyContainer<enum eEShapeMaterial>"),
	STATIC_ILLUMINATED("bTPropertyContainer<enum eEStaticIlluminated>"),
	STATIC_LIGHING_TYPE("bTPropertyContainer<enum eEStaticLighingType>"),
	STRIP_SPAWNING("bTPropertyContainer<enum eEStripSpawning>"),
	CAST_TYPE("bTPropertyContainer<enum gECastType>"),
	ENCLAVE_STATUS("bTPropertyContainer<enum gEEnclaveStatus>"),
	SKILL_CATEGORY("bTPropertyContainer<enum gESkillCategory>"),
	SPELL_DEITY("bTPropertyContainer<enum gESpellDeity>"),
	SPELL_TARGET("bTPropertyContainer<enum gESpellTarget>"),
	SPELL_TYPE("bTPropertyContainer<enum gESpellType>"),
	TREASURE_DISTRIBUTION("bTPropertyContainer<enum gETreasureDistribution>");
	
	private String value;
	private KnownDataTypes(String val) { value = val; }

	public String getValue() { return value; }
	public static KnownDataTypes fromValue(String val) {
		for(KnownDataTypes attr: KnownDataTypes.values()) if(val.equals(attr.getValue())) return attr;
		if(val.startsWith("bTPropertyContainer<enum")) return UNKNOWN_ENUM;
		return UNKNOWN;
	}
}
