package main.enums;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
public enum ShapeGroup {

	UNDEFINED				(new byte[] { 1, 00,  0, 00, 00, 00 }),
	STATIC					(new byte[] { 1, 00,  1, 00, 00, 00 }),
	DYNAMIC					(new byte[] { 1, 00,  2, 00, 00, 00 }),
	SHIELD					(new byte[] { 1, 00,  3, 00, 00, 00 }),
	MELEE_WEAPON			(new byte[] { 1, 00,  4, 00, 00, 00 }),
	PROJECTILE				(new byte[] { 1, 00,  5, 00, 00, 00 }),
	MOVEMENT				(new byte[] { 1, 00,  6, 00, 00, 00 }),
	WEAPON_TRIGGER			(new byte[] { 1, 00,  7, 00, 00, 00 }),
	PARADE_SPHERE			(new byte[] { 1, 00,  8, 00, 00, 00 }),
	TREE_TRUNK				(new byte[] { 1, 00,  9, 00, 00, 00 }),
	TREE_BRANCHES			(new byte[] { 1, 00, 10, 00, 00, 00 }),
	CAMERA					(new byte[] { 1, 00, 11, 00, 00, 00 }),
	MOVEMENT_ZONE_NPC		(new byte[] { 1, 00, 12, 00, 00, 00 }),
	HEIGHT_REPULSOR			(new byte[] { 1, 00, 13, 00, 00, 00 }),
	CLOTH					(new byte[] { 1, 00, 14, 00, 00, 00 }),
	PHYSICAL_BODY_PART		(new byte[] { 1, 00, 15, 00, 00, 00 }),
	KEYFRAMED_BODY_PART		(new byte[] { 1, 00, 16, 00, 00, 00 }),
	CAMERA_OBSTACLE			(new byte[] { 1, 00, 17, 00, 00, 00 }),
	PROJECTILE_LEVEL		(new byte[] { 1, 00, 18, 00, 00, 00 }),
	TRIGGER					(new byte[] { 1, 00, 19, 00, 00, 00 }),
	DOOR					(new byte[] { 1, 00, 20, 00, 00, 00 });

	private byte[] value;
	private ShapeGroup(byte[] value) { this.value = value; }

	public byte[] getValue() { return value; }

	public static ShapeGroup fromValue(byte[] value) {
		for(ShapeGroup attr: ShapeGroup.values()) {
			if(	value[0] == attr.getValue()[0] &&
				value[1] == attr.getValue()[1] &&
				value[2] == attr.getValue()[2] &&
				value[3] == attr.getValue()[3] &&
				value[4] == attr.getValue()[4] &&
				value[5] == attr.getValue()[5] ) return attr;
		}
		return UNDEFINED;
	}
}
