package main.enums;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
public enum ShapeMaterial {

	NONE					(new byte[] { 1, 00,  0, 00, 00, 00 }),
	WOOD					(new byte[] { 1, 00,  1, 00, 00, 00 }),
	METAL					(new byte[] { 1, 00,  2, 00, 00, 00 }),
	WATER					(new byte[] { 1, 00,  3, 00, 00, 00 }),
	STONE					(new byte[] { 1, 00,  4, 00, 00, 00 }),
	EARTH					(new byte[] { 1, 00,  5, 00, 00, 00 }),
	ICE						(new byte[] { 1, 00,  6, 00, 00, 00 }),
	LEATHER					(new byte[] { 1, 00,  7, 00, 00, 00 }),
	CLAY					(new byte[] { 1, 00,  8, 00, 00, 00 }),
	GLASS					(new byte[] { 1, 00,  9, 00, 00, 00 }),
	FLESH					(new byte[] { 1, 00, 10, 00, 00, 00 }),
	SNOW					(new byte[] { 1, 00, 11, 00, 00, 00 }),
	DEBRIS					(new byte[] { 1, 00, 12, 00, 00, 00 }),
	FOLIAGE					(new byte[] { 1, 00, 13, 00, 00, 00 }),
	MAGIC					(new byte[] { 1, 00, 14, 00, 00, 00 }),
	GRASS					(new byte[] { 1, 00, 15, 00, 00, 00 }),
	SPRING_AND_DAMPER_1		(new byte[] { 1, 00, 16, 00, 00, 00 }),
	SPRING_AND_DAMPER_2		(new byte[] { 1, 00, 17, 00, 00, 00 }),
	SPRING_AND_DAMPER_3		(new byte[] { 1, 00, 18, 00, 00, 00 }),
	DAMAGE					(new byte[] { 1, 00, 19, 00, 00, 00 }),
	SAND					(new byte[] { 1, 00, 20, 00, 00, 00 }),
	MOVEMENT				(new byte[] { 1, 00, 21, 00, 00, 00 });

	private byte[] value;
	private ShapeMaterial(byte[] value) { this.value = value; }

	public byte[] getValue() { return value; }

	public static ShapeMaterial fromValue(byte[] value) {
		for(ShapeMaterial attr: ShapeMaterial.values()) {
			if(	value[0] == attr.getValue()[0] &&
				value[1] == attr.getValue()[1] &&
				value[2] == attr.getValue()[2] &&
				value[3] == attr.getValue()[3] &&
				value[4] == attr.getValue()[4] &&
				value[5] == attr.getValue()[5] ) return attr;
		}
		return NONE;
	}
}
