package test;

/**
 * 
 * Copyright 2007 - Dirk Becker, Germany
 * 
 * This Code ist FreeWare and OpenSource, feel free to Copy or Modify it!
 * 
 *  Commercial use is absolutely forbidden!
 *  This entail the use by someone who act for free in order of an commercial oriented company.
 *  Please stick to this rules!
 * 
 */
import java.io.File;
import java.io.FilenameFilter;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import main.data.Converter;


public class TypeCheck {
	
	byte[]	Bit16 = new byte[2];
	byte[]	Bit32 = new byte[4];
	RandomAccessFile raf;
	List<File> tpleFiles = new ArrayList<File>();
	List<String> types = new ArrayList<String>();
	Map<String, Integer> strings = new HashMap<String, Integer>();
	
	public void check(File path) {
		read(path);
		for(File f: tpleFiles) readStructure(f);
		
		Collections.sort(types);
		for(String type: types) {
			System.out.println(type);
		}
	}
	

	private void readStructure(File f) {
		try {
			raf = new RandomAccessFile(f, "r");
			raf.seek(10);
			raf.read(Bit32);
			long point = Converter.UInt32ToLong(Bit32);
			raf.seek(point+9);
			
			while(raf.read(Bit16)>0) {
				String value = "";
				for(int c=0; c<Converter.UInt16ToLong(Bit16); c++)
					value += (char)raf.readUnsignedByte();
				if(!value.endsWith(".tple")) {
					if(strings.containsKey(value))
						strings.put(value, strings.get(value)+1);
					else {
						strings.put(value, 1);
						types.add(value);
					}
				}
			}

		}
		catch(Exception e) { e.printStackTrace(); }
	}

	private void read(File template) {
		try {
			if(template.isDirectory()) {
				for(String loc: template.list(new tpleFilter())) {
					read(new File(template.getAbsolutePath() + "\\" + loc));
				}
			}
			else tpleFiles.add(template);
		}
		catch(Exception e) { e.printStackTrace(); }
	}
	
	private class tpleFilter implements FilenameFilter {
		public boolean accept(File dir, String name) {
			if(name.indexOf('.')<0) return true;
			else if(name.endsWith(".tple")) return true;
			else return false;
		}
	}

}
